// button.cpp : Defines the entry point for the application.
//

#include "stdafx.h"
#include <windows.h>

LRESULT CALLBACK WindowFunc(HWND, UINT,WPARAM,LPARAM);
char * szClassName = "SxdButtonTest";

PAINTSTRUCT	ps;
HINSTANCE	hInstance;
HBITMAP		hBitmap;
BITMAP		bm;
POINT		ptCursor;
RECT		Rects;
HRGN		ResRgn;
HWND		hwnd, hbtn;
HDC			hDc, hMemDC;

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInst, LPSTR lpszArgs, int nWinMode)
{
	MSG msg;
	WNDCLASS wc;

	wc.lpszMenuName  = NULL;
	wc.style         = CS_HREDRAW | CS_VREDRAW;
	wc.lpfnWndProc   = WindowFunc;
	wc.cbClsExtra    = 0;
	wc.cbWndExtra    = 0;
	wc.hInstance     = hInstance;
	wc.hIcon         = LoadIcon(NULL, IDI_APPLICATION);
	wc.hCursor       = LoadCursor(NULL, IDC_ARROW);
	wc.hbrBackground = CreateSolidBrush (RGB(255,255,255));
	wc.lpszClassName = szClassName;

	if(!RegisterClass(&wc)) return 0;

	hwnd = CreateWindow(szClassName, "SxdButtonTest", WS_BORDER|WS_CAPTION|WS_SYSMENU|WS_MINIMIZEBOX,
						200, 200, 230, 160,	NULL, NULL, hInstance, NULL );
	ShowWindow(hwnd, SW_SHOW);
	UpdateWindow(hwnd);

	hbtn = CreateWindow("BUTTON", "OK",	WS_VISIBLE|WS_CHILD, 40, 40, 150, 50, hwnd, NULL, hInstance, NULL);

	while(GetMessage(&msg, NULL,0,0))
	{
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
	return msg.wParam;
}

LRESULT CALLBACK WindowFunc(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch(message)
	{
	case WM_SETCURSOR:
		{
		GetCursorPos (&ptCursor);
		hDc = GetDC (hwnd);
		ScreenToClient (hwnd, &ptCursor);
		if (ptCursor.x >= 10 && ptCursor.x <= 210 && ptCursor.y >= 10 && ptCursor.y <= 90)
		{
			hBitmap = (HBITMAP)LoadImage(NULL, "Button22.bmp", IMAGE_BITMAP, 0, 0, LR_LOADFROMFILE);
			if (!hBitmap) return NULL;
		}
		else
		{
			hBitmap = (HBITMAP)LoadImage(NULL, "Button22.bmp", IMAGE_BITMAP, 0, 0, LR_LOADFROMFILE);
			if (!hBitmap) return NULL;
		}
		ReleaseDC (hwnd, hDc);
		}break;

	case WM_COMMAND:
		switch (LOWORD(wParam))
		{
		case BN_CLICKED: 
			if (hbtn == (HWND)lParam)
				MessageBox (NULL,"1","1",NULL);
		}break;

	case WM_CREATE:
		{
			hDc = GetWindowDC(hbtn);
			hMemDC = CreateCompatibleDC(hDc);
			SelectObject(hMemDC, hBitmap);
			GetWindowRect(hbtn, &Rects);
			GetClientRect(hbtn, &Rects);

			hBitmap = (HBITMAP)LoadImage(NULL, "Button.bmp", IMAGE_BITMAP, 0, 0, LR_LOADFROMFILE);
			if (!hBitmap) return NULL;

			ResRgn = CreateRectRgn(0, 0, Rects.right, Rects.top);

			SetWindowRgn(hbtn, ResRgn, TRUE);
			InvalidateRect(hbtn, 0, false);
			ReleaseDC(hbtn, hDc);
			DeleteDC(hMemDC);

			ShowWindow(hbtn, SW_SHOW);
			UpdateWindow(hbtn);
		}break;

	case WM_DESTROY:
		{
			DeleteObject(hBitmap);
			PostQuitMessage(0);			
		}break;

	case WM_PAINT:
		{
			GetClientRect(hbtn, &Rects);
			hDc = BeginPaint(hbtn, &ps);
			hMemDC = CreateCompatibleDC(hDc);
			SelectObject(hMemDC, hBitmap);
			BitBlt(hDc, 0, 0, Rects.right, Rects.bottom, hMemDC, 0, 0, SRCCOPY);			
			ShowWindow(hbtn, SW_SHOW);			
			DeleteDC(hMemDC);
			EndPaint(hbtn, &ps);			
		}break;

	default:
		return DefWindowProc(hwnd, message, wParam, lParam);
	}
	return 0;
}